. .\0_globals.ps1

qlik context use $QlikSaaSContext

# Note: as of 2023-09-07 the available roles are
# 		* Managed Spaces: basicconsumer, consumer, contributor, dataconsumer, facilitator, publisher
#		* Shared Spaces: codeveloper, consumer, dataconsumer, facilitator, producer

if($MIGRATIONFROM -eq "QlikSense")
{
	#SpaceName, email, roles
    $assignments = Import-Csv -Path $DATA\spaceuserassignments.csv -Header "SpaceName", "email", "roles" | Select-Object -skip 1

}
elseif($MIGRATIONFROM -eq "QlikView")
{
	#SpaceId1,AppUsers
    $assignments = Import-Csv -Path $DATA\spacesUsers.csv -Header "SpaceName", "subject" | Select-Object *,@{Name='roles';Expression={'consumer'}}  -skip 1
	#$assignments = Import-Csv -Path $DATA\spacesUContributors.csv -Header "SpaceName", "subject" | Select-Object *,@{Name='roles';Expression={'contributor'}}  -skip 1
	#Write-Host $assignments
}
else 
{
    Write-Host "Invalid MIGRATIONFROM Value."
    exit;
}

foreach ($assignment in $assignments)
{
	
	$spacename = $assignment.SpaceName
	$roles = $assignment.roles

	if($MIGRATIONFROM -eq "QlikSense")
	{
		$email = $assignment.email
		$userId =  qlik user ls --email $email -q
		
	}
	elseif($MIGRATIONFROM -eq "QlikView")
	{
		$subject = $assignment.subject
		$userId  =  qlik user ls --subject $subject -q	
	}

	Write-Host $spacename, $subject, $email, $roles

	$spaceId = qlik space ls --name $spacename -q
	#$spaceId = qlik space filter --names $spacename -q
	#Write-Host "spaceid: $spaceId"
	
	#Write-Host "userId: $userId"

	#Write-Host $spaceId, $userId
	
	#create the assignment
	qlik space assignment create --spaceId $spaceId --assigneeId $userId --roles "$roles" --type user
}